import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.PrintStream;
import java.util.Scanner;

import javax.swing.JFileChooser;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.filechooser.FileNameExtensionFilter;

/**
 * Listener for the file menu
 * @author Marcio B
 *
 */
public class FileMenuListener implements ActionListener{
	  private DigitalCircuit circuit;
	 /**
	  * Constructor of the class
	  * @param c DigitalCircuit
	  */
	  public FileMenuListener (DigitalCircuit c) {
	     circuit = c;

	  }
	  /**
	   * Takes the action and do a method for that
	   */
	  public void actionPerformed(ActionEvent e) {
	      JMenuItem menuItem = (JMenuItem)(e.getSource());
	      String text = menuItem.getText();
	      
	 if (text.equals("Open")){ 
         FileReader data=null;
         JFileChooser chooser = new JFileChooser();
         FileNameExtensionFilter filter = new FileNameExtensionFilter(".dc data files", "dc");
         chooser.setFileFilter(filter);
         int returnVal = chooser.showOpenDialog(null);
         if(returnVal == JFileChooser.APPROVE_OPTION) {
           try {
             data = new FileReader(chooser.getSelectedFile());
           } catch(FileNotFoundException ef) {
         	  JOptionPane.showMessageDialog(null, "Can´t open the file.\nPlease try again. ","Error", JOptionPane.ERROR_MESSAGE);  
             return;
           }
           circuit.addOpenFile(data);
         }
       }
     
     if (text.equals("Save")){
   	  PrintStream outData = null;
   	  JFileChooser fc = new JFileChooser();
   	  FileNameExtensionFilter fil = new FileNameExtensionFilter(".dc", "dc");
   	  fc.setFileFilter(fil);

   	  int returnV = fc.showSaveDialog(null);
   	  if(returnV == JFileChooser.APPROVE_OPTION) {
   		  try {
   			  outData = new PrintStream(fc.getSelectedFile());
   		  } catch(FileNotFoundException ef) {
   			  JOptionPane.showMessageDialog(null, "Can´t save the file.\nPlease try again. ","Error", JOptionPane.ERROR_MESSAGE);

   			  return;
   		  }
   		  circuit.addSaveFile(outData);
   	  }
     }

     if (text.equals("Exit")){ 
 		int result = JOptionPane.showConfirmDialog(null,"Exit from Circuit Simulator ?","Exit",JOptionPane.YES_NO_OPTION); 
 		if (result == JOptionPane.YES_OPTION) 
 			System.exit(0);
     }
}
}
